{*************************************************************}
{*                Unit  Funcs v3.0                           *}
{*   Copyright (c) 1996-99 by Dmitry Beloshistov [-=BDS=-]   *}
{*           Turbo/Borland Pascal version                    *}
{*             String manipulation unit                      *}
{*************************************************************}

{ Based on source code of: }
{   FUNCS unit (c) 1988 by J.Tal (Rolling Medical/Dental System)       }
{   CodePageDetector source (c) Sergey Korowkin OSP Dos Navigator team }

Unit FaFuncs;
{$D-,L-,O+,F+,B-}
Interface
Uses Objects;

Const
    CommentChar:char=';';                {default comment char}

type
    PXltBuffer=^TXltBuffer;              {xlat buffer}
    TXltBuffer=array[0..SizeOf(TByteArray)] of char;

 TKeyMap = (kmNone, kmAscii, kmAnsi, kmKoi8r);

 { This object was written by Sergey Korowkin }
 { OSP Dos Navigator team                     }

 PCodePageDetector=^TCodePageDetector;
 TCodePageDetector = object(TObject)
   constructor Init;
   destructor  Done; virtual;
   procedure   CheckString(const S: String);
   function    DetectCodePage: TKeyMap;
 private
   Koi, KoiA, Win, WinA, Win2: LongInt;
 end;

{ ID`s of conversion tables }
const
      xTblDos=0; xTblWin=1; xTblKoi=2;
      xTblMic=3; xTblMkt=4;

function Lowcase(C:Char):Char;
{ LowCase('A') = 'a' }
Function FillStrChar(Ch:Char; Num:integer):String;
{ FillStrChar('#',5)='#####' }
function Spaces(Num:integer):String;
{ Spaces(5) = '     ' }
Function DelCharStr(S:String; Chs:TCharSet):String;
{ DelCharStr('AABBCCDD',['A','B'])='CCDD' }
Function ChangeFileExt(FileName,NewExt:String):String;
{ ChangeFileExt('FILE.DAT','TXT')='FILE.TXT' }
function BakFile(FileName:String):String;
{ BakFile('FILE.DAT')='FILE.BAK' }
function Bool(x : boolean):integer;
{ Bool(True)=1  Bool(FALSE)=0 }
function UnBool(x:integer):boolean;
{ UnBool(1)=TRUE UnBool(0)=FALSE }
Function LeftTrimDelim(S:String;Delim:TCharSet):String;
{ LeftTrimDelim(' AAAA    ',[' '])='AAAA   ' }
Function RightTrimDelim(S:String; Delim:TCharSet):String;
{ RightTrimDelim('   AAAA ',[' '])='    AAAA' }
Function TrimDelim(S:String; Delim:TCharSet):String;
{ TrimDelim('.,..,AAAA.,.,..,',[',','.'])='AAAA' }
Function Trim(S:String):String;
{ Trim(' AAAA      ')='AAAA' }
Function LeftTrim(S:String):String;
{ LeftTrim('  AAAAAA  ')='AAAAAA  '}
Function RightTrim(S:String):String;
{ RightTrim('  AAAAAA  ')='  AAAAAA'}
Function FirstWord(S:String; Delims:TCharSet):String;
{ FirstWord(' AAA BBB CCC ',[' '])='AAA' }
Function GetFirstWord(var S:String; Delims:TCharSet):String;
{ GetFirstWord(' AAA BBB CCC ',[' '])='AAA' S='BBB CCC'}
Function LastWord(S:String; Delims:TCharSet):String;
{ LastWord(' AAA BBB CCC ',[' '])='CCC'}
Function LastPos(SubStr,Str:String):integer;
{ LastPos('CC','AACCBBCC')=7}
Function GetLastWord(var S:String; Delims:TCharSet):String;
{ GetLastWord('AAA BBB CCC',[' ']='CCC' S='AAA BBB'}
Function ReplaceChar(S:String; OldChar,NewChar:char):String;
{ ReplaceChar('AAAAAA','A','B')='BBBBBB' }
Function DelDupCh(S:String; DupCh:Char):String;
{ DelDupCh('AABBAABB','A')='ABBABB' }
Function DelSpace(S:String):String;
{ DelSpace(' a b c d ff')='abcdff' }
Function DelDupeSpace(S:String):String;
{ DelDupSpace(' a     b c d ff')=' a b c d ff' }
Function DelSubStr(SubStr,S:String):String;
{ DelSubStr('AA','AABBCCDD')='BBCCDD' }
Function ReplaceStr(S:String; OldSubStr,NewSubStr:String):string;
{ ReplaceStr('AABBCCDD','BB','ff')='AAffCCDD' }
Function LeftStr(S:String; Len:integer):String;
{ LeftStr('12345678',5)='12345' }
Function RightStr(S:String; Len:integer):String;
{ RightStr('12345678',5)='45678' }
function LeftPad(S:String; Len:integer):String;
{ LeftPad('AAA',5)='  AAA'}
function RightPad(S:String; Len:integer):String;
{ RightPad('AAA',5)='AAA  '}
function FnxTrm(S:String):boolean;
{ FnxTrm('  ')=True FnxTrm(' a ')=FALSE }
function StrToInt(S:String):longint;
{ StrToInt('123')=123 }
function IntToStr(L:Longint):String;
{ IntToStr(123)='123' }
Function MidStr(S:String; FirstPos,Len:integer):String;
{ MidStr('ABCDDEFG',4,2)='DD'}
Function ModifyStr(S:String; FirstPos,Len:integer; NewStr:String):String;
{ ModifyStr('ABCDE',2,3,'GG')='AGGE' }
Function ValidStr(S:String; ValidChars:TCharSet):boolean;
{ ValidStr('ABC',['A'..'C'])=True ValidStr('ABC',['A','B'])=False }
Function ValidStrS(S,ValidChars:String):boolean;
{ ValidStrS('ABCA','ABC')=True ValidStrS('ABC','AB')=False }
Function IntToHex(hex:Longint):string;
{ IntToHex(255)='FF' }
function HexToInt(HexStr:String):longint;
{ HexToInt('FF')=255}
function IntToBin(Bin:Longint):String;
{ IntToBin(5)='101' }
Function BinToInt(BinS:String):longint;
{ BinToInt('101')=5 }
Function LeadZero(S:String; Len:integer):String;
{ LeadZero('123',5)='00123'}
function Fnsz(N:Longint):String;
{ Fnsz(5)='05' }
function Lz(N:Longint):String;
{ lz(5)='05' }
Function PrintUsing(Mask:String; Number:Real):String;
{ PrintUsing('#,###.##',12345.67)='1,2345.67'}
Function UpperCase(S:string):String;
{ UpperCase('aaaaa')='AAAAA' }
Function RUpCase(Ch: Char): Char;
{ RUpCase('')='' }
Function RUpperStr(s:string):String;
{ RUpperStr('')='' }
Function RLowCase(Ch:Char):Char;
{ RLowCase('')='' }
Function RLowStr(S:String):String;
{ RLowStr('')='' }
Function LowStr(s:string):String;
{ LowStr('AABBCC')='aabbcc' }
Function DelComment(s:string):String;
{ DelComment('MyValue=0 ; comment string') = 'MyValue=0'}
Function cntrs(s:string; Len:integer):string;
{cntrs('a',3)=' a '}
Function DeTab(s:string; TabSize:Byte):string;
{ Tabulation -> spaces }
Function DLS(S:string):string;
{ DLS('C:\WORK\')='C:\WORK' }
Function just(S:String;Len,LRC:longint):string;
{ just('a',3,1) = '  a'}
{ just('a',3,2) = 'a  '}
{ just('a',3,3) = ' a '}
Function FilterStr(S:String;FilterChars:TCharSet;ReplaceChar:Char):String;
{FilterStr(' A A A A ',[' '],'.')='.A.A.A.A.'}
function XltStr(S:String; SourTable,DestTable:Integer):String;
{ string conversion to another code table }
Procedure XltBuf(var Buffer:PXltBuffer;NChars:Word;SourTable,DestTable:integer);
{ buffer conversion to another code table }
Function OemToAnsi(S:String):String;
{ DOS -> WIN }
Function AnsiToOem(S:String):String;
{ WIN -> DOS }
Function OemToKoi(S:String):String;
{ DOS -> KOI8r }
Function KoiToOem(S:String):String;
{ KOI8r -> DOS }
Function ConvertStr(S,SourceChars,DestChars:String):String;
{ ConvertStr('ABCD','AB','EF')='EFCD' }
Function DetectCodePage(S:String):Integer;
{ Detect code page for string }
Function UpWordFirstCh(S:String; Delims:TCharSet):String;
{ UpWordFirtsCh('aa bb cc')='Aa Bb Cc'}
Function WordCount(S:String; Delims:TCharSet):integer;
{ WordCount('AA BB CC',[' '])=3 }
Function WordPos(S:String; WordNum:integer; Delims:TCharSet):integer;
{ WordPos('AA BB',2,[' '])=3 }
Function ExtractWord(S:String; WordNum:integer; Delims:TCharSet):String;
{ ExtractWord('AA BB CC',2,[' '])='BB' }
Function PercentStr(Cur,Max:Longint; EmptyCh,FillCh:Char; Len:byte):String;
{ PercentStr(50,100,'.','#',10)='#####.....'); }
Function FloatToStr(R:Real):String;
{ FloatToStr(1.234) = '1.234' }
Function StrToFloat(S:String):Real;
{ StrToFloat('1.234') = 1.234 }

Implementation
{--------------------------------------------}
function LowCase(C:Char):Char; assembler;
{ LowCase for english chars 'A'..'Z' only }
asm
    mov al,C
    cmp al,'A'
    jl  @@1
    cmp al,'Z'
    jg  @@1
    add al,20h
 @@1:
end;
{--------------------------------------------}
Function FillStrChar(Ch:Char; Num:integer):String;
var S:String;
begin
 FillChar(S,SizeOf(S),Ch);
 S[0]:=Char(Lo(Num));
 FillStrChar:=S;
end;
{--------------------------------------------}
function spaces(Num:integer):String;
begin
 Spaces:=FillStrChar(' ',Num);
end;
{--------------------------------------------}
Function DelCharStr(S:String; Chs:TCharSet):String;
var i:integer;
begin
 for i:=Length(S) downto 1 do
  if (S[i] in Chs) then Delete(S,i,1);
 DelCharStr:=S;
end;
{--------------------------------------------}
Function ChangeFileExt(FileName,NewExt:String):String;
var P:integer;
begin
 NewExt:=DelCharStr(NewExt,['.']);
 P:=Pos('.',FileName);
 if P=0 then ChangeFileExt:='.'+NewExt
 else ChangeFileExt:=Copy(FileName,1,P)+NewExt;
end;
{--------------------------------------------}
function bakfile(FileName:String):String;
begin
 BakFile:=ChangeFileExt(FileName,'BAK');
end;
{--------------------------------------------}
function bool(x : boolean):integer;
begin
 if x then bool :=1 else bool := 0
end;
{--------------------------------------------}
function unbool(x:integer):boolean;
begin
 unbool:=not (x=0);
end;
{--------------------------------------------}
Function LeftTrimDelim(S:String;Delim:TCharSet):String;
begin
 while (S<>'') and (S[1] in Delim) do delete(S,1,1);
 LeftTrimDelim:=S;
end;
{--------------------------------------------}
Function RightTrimDelim(S:String; Delim:TCharSet):String;
begin
 while (S<>'') and (S[length(S)] in Delim) do delete(S,length(S),1);
 RightTrimDelim:=S;
end;
{--------------------------------------------}
Function TrimDelim(S:String; Delim:TCharSet):String;
begin
 TrimDelim:=RightTrimDelim(LeftTrimDelim(S,Delim),Delim);
end;
{--------------------------------------------}
Function Trim(S:String):String;
begin
 Trim:=TrimDelim(S,[' ']);
end;
{--------------------------------------------}
Function LeftTrim(S:String):String;
begin
 LeftTrim:=LeftTrimDelim(S,[' ']);
end;
{--------------------------------------------}
Function RightTrim(S:String):String;
begin
 RightTrim:=RightTrimDelim(S,[' ']);
end;
{--------------------------------------------}
Function FirstWord(S:String; Delims:TCharSet):String;
var SBuf:String;
begin
 Sbuf:=''; S:=TrimDelim(S,Delims);
 while (S<>'') and not (S[1] in Delims) do
  begin Sbuf:=Sbuf+S[1]; delete(S,1,1); end;
 FirstWord:=Sbuf;
end;
{--------------------------------------------}
Function LastWord(S:String; Delims:TCharSet):String;
var Sbuf:String;
begin
 Sbuf:=''; S:=TrimDelim(S,Delims);
 while (S<>'') and not (S[Length(S)] in Delims) do
  begin Sbuf:=S[Length(S)]+Sbuf; delete(S,Length(S),1); end;
 LastWord:=Sbuf;
end;
{--------------------------------------------}
Function LastPos(SubStr,Str:String):integer;
var i:integer;
    P:integer;
    O:integer;
begin
 P:=0; O:=0;
 I:=Pos(SubStr,Str);
 repeat
  if i<>0 then begin
                 P:=i; Delete(Str,i,Length(SubStr));
                 I:=Pos(SubStr,Str);
                 if I>0 then O:=O+Length(SubStr);
               end;
 until i=0;
 LastPos:=P+O;
end;
{--------------------------------------------}
Function GetLastWord(var S:String; Delims:TCharSet):String;
var SBuf:String;
begin
 S:=TrimDelim(S,Delims);
 Sbuf:=LastWord(S,Delims);
 Delete(S,LastPos(Sbuf,S),Length(SBuf));
 S:=TrimDelim(S,Delims);
 GetLastWord:=SBuf;
end;
{--------------------------------------------}
Function GetFirstWord(var S:String; Delims:TCharSet):String;
var SBuf:String;
begin
 S:=TrimDelim(S,Delims);
 Sbuf:=FirstWord(S,Delims);
 Delete(S,Pos(Sbuf,S),Length(Sbuf));
 S:=TrimDelim(S,Delims);
 GetFirstWord:=Sbuf;
end;
{--------------------------------------------}
Function ReplaceChar(S:String; OldChar,NewChar:char):String;
var P:integer;
begin
 repeat
   P:=Pos(OldChar,S); if P>0 then S[P]:=NewChar;
 until P=0;
 ReplaceChar:=S;
end;
{--------------------------------------------}
Function DelDupCh(S:String; DupCh:Char):String;
var N:integer;
begin
 repeat
  N:=Pos(DupCh+DupCh,S);
  if N>0 then Delete(S,N,1);
 until N=0;
 DelDupCh:=S;
end;
{--------------------------------------------}
Function DelSpace(S:String):String;
begin
 DelSpace:=DelCharStr(S,[' ']);
end;
{--------------------------------------------}
Function DelDupeSpace(S:String):String;
begin
 DelDupeSpace:=DelDupCh(S,' ');
end;
{--------------------------------------------}
Function DelSubStr(SubStr,S:String):String;
var N:integer;
begin
 repeat
  N:=Pos(SubStr,S);
  if N>0 then Delete(S,N,Length(SubStr));
 until N=0;
 DelSubStr:=S;
end;
{--------------------------------------------}
Function ReplaceStr(S:String; OldSubStr,NewSubStr:String):string;
var N:integer;
begin
 repeat
  N:=Pos(OldSubStr,S);
  if N>0 then
   begin Delete(S,N,Length(OldSubStr)); Insert(NewSubStr,S,N); end;
 until N=0;
 ReplaceStr:=S;
end;
{--------------------------------------------}
Function LeftStr(S:String; Len:integer):String;
begin
 LeftStr:=Copy(S,1,Len);
end;
{--------------------------------------------}
Function RightStr(S:String; Len:integer):String;
begin
 RightStr:=copy(S,length(S)-Len+1,Len);
end;
{--------------------------------------------}
function LeftPad(S:String; Len:integer):String;
begin
 if Len>Length(S) then LeftPad:=Spaces(Len-Length(S))+S
 else LeftPad:=S;
end;
{--------------------------------------------}
function RightPad(S:String; Len:integer):String;
begin
  if Len>Length(S) then RightPad:=S+spaces(Len-Length(S))
  else RightPad:=S;
end;
{--------------------------------------------}
function FnxTrm(S:String):boolean;
begin
 FnxTrm:=(Trim(S)='');
end;
{--------------------------------------------}
function StrToInt(S:String):longint;
var Er:integer;
    L:longint;
begin
 Val(DelSpace(S),L,Er);
 if Er<>0 then StrToInt:=MaxLongint else StrToInt:=L;
end;
{--------------------------------------------}
function IntToStr(L:Longint):String;
var S:string;
begin
 Str(L,S); IntToStr:=S;
end;
{--------------------------------------------}
Function MidStr(S:String; FirstPos,Len:integer):String;
begin
 MidStr:=Copy(S,FirstPos,Len);
end;
{--------------------------------------------}
Function ModifyStr(S:String; FirstPos,Len:integer; NewStr:String):String;
begin
 Delete(S,FirstPos,Len);
 Insert(S,NewStr,FirstPos);
 ModifyStr:=S;
end;
{--------------------------------------------}
Function ValidStr(S:String; ValidChars:TCharSet):boolean;
var i:integer;
begin
 ValidStr:=False;
 for i:=1 to Length(S) do if not (S[i] in ValidChars) then exit;
 ValidStr:=True;
end;
{--------------------------------------------}
Function ValidStrS(S,ValidChars:String):boolean;
var ChS:TCharSet;
    i:integer;
begin
 Chs:=[];
 for i:=1 to Length(ValidChars) do Chs:=Chs+[ValidChars[i]];
 ValidStrS:=ValidStr(S,ChS);
end;
{--------------------------------------------}
Function IntToHex(hex:Longint):string;
var hexS: string;
    hex_temp: LongINT;
    HexDig: string;
BEGIN
  HexDig:='0123456789ABCDEF'; hexS:='';
  while hex > 0 do begin
    hexS:=hexDig[(hex and 15)+1]+hexS;
    hex:=hex DIV 16;
  end;
  while Length(HexS)<2 do HexS:='0'+HexS;
  IntToHex:=HexS;
END;
{--------------------------------------------}
function HexToInt(HexStr:String):longint;
VAR hex:longint;
    hexDig: string;
BEGIN
  hexDig:='0123456789ABCDEF';
  if not ValidStrS(HexStr,HexDig) then begin HexToInt:=MaxLongint; exit; end;
  Hex:=0;
  WHILE HexStr<>'' DO
   begin
     hex:=hex*16+Pos(HexStr[1],HexDig)-1;
     Delete(HexStr,1,1);
   END;
 HexToInt:=Hex;
END;
{--------------------------------------------}
function IntToBin(Bin:Longint):String;
VAR binS: string;
BEGIN
  binS:='';
  if bin=0 then binS:='0'
  else WHILE bin <> 0 DO
        begin
         IF (Bin and 1) = 1 THEN binS:='1'+binS
         ELSE binS:='0'+binS;
         bin := bin shr 1;
        END;
  IntToBin:=BinS;
END;
{--------------------------------------------}
Function BinToInt(BinS:String):longint;
var Bin,Mult:longint;
    i:integer;
begin
 if not ValidStr(BinS,['0','1']) then begin BinToInt:=MaxLongint; exit; end;
 Mult:=1; Bin:=0;
 for i:=Length(BinS) downto 1 do
  begin
   if BinS[i]='1' then Bin:=Bin+Mult;
   Mult:=Mult shl 1;
  end;
 BinToInt:=Bin;
end;
{--------------------------------------------}
Function LeadZero(S:String; Len:integer):String;
begin
 while Length(S)<Len do S:='0'+S;
 LeadZero:=S;
end;
{--------------------------------------------}
function Fnsz(N:Longint):String;
begin
 Fnsz:=LeadZero(IntToStr(N),2);
end;
{--------------------------------------------}
Function Lz(N:Longint):String;
begin
 Lz:=Fnsz(N);
end;
{--------------------------------------------}
Function PrintUsing(Mask:String; Number:Real):String;
const Comma:char=',';
      Point:char='.';
      Minus:char = '-';
VAR  FldWidth,IntLen,i,j,places,PointPos:INTEGER;
     UseComma,IsDec,IsNeg:boolean;
     OutS,IntStr:string;
BEGIN
     IsNeg:=number<0; number:=abs(number);
     places:=0;       FldWidth:=length(mask);
     UseComma:=pos(comma,mask)>0; IsDec:=pos(point,mask)>0;
     if IsDec then
      BEGIN
        pointpos:=pos(point,mask);
        places:=fldwidth-pointpos;
      END;
     str(number:0:places,outS);
     if UseComma then
       BEGIN
         j := 0;
         IntStr:=copy(outS,1,length(outS)-places);
         IntLen:=length(IntStr);
         if IsDec then dec(IntLen);
         FOR i:=IntLen DOwnto 2 DO
            BEGIN
             inc(j);
             if (j mod 3)=0 then insert(comma,outs,i)
            end
       END;
    OutS:=LeftPad(OutS,FldWidth);
    if (IsNeg) then outs:=minus+outs;
    printusing :=outs;
END; (* printusing *)
{--------------------------------------------}
Function UpperCase(S:string):String;
VAR i:Integer;
BEGIN
  For i:=1 TO Length(S) DO S[i] := UpCase(S[i]);
  UpperCase:=S;
END;
{-----------------------------------------------------}
Function RUpCase(Ch: Char): Char;
begin
  if Ch in [''..''] then Dec(Ch, 32)
  else if Ch in [''..''] then Dec(Ch, 80)
       else Ch:=system.UpCase(Ch);
  RUpCase := Ch;
end;
{-----------------------------------------------------}
Function RLowCase(Ch:Char):Char;
begin
 if Ch in [''..''] then Inc(Ch,32)
 else if Ch in [''..''] then Inc(Ch,80)
      else Ch:=LowCase(Ch);
 RLowCase:=Ch;
end;
{-----------------------------------------------------}
Function RLowStr(S:String):String;
var i:integer;
begin
 for i:=1 to Length(S) do S[i]:=RLowCase(S[i]);
 RLowStr:=S;
end;
{-----------------------------------------------------}
Function RUpperStr(s:string):String;
var i:integer;
begin
 for i:=1 to length(s) do s[i]:=RUpCase(s[i]);
 RUpperStr:=S;
end;
{-----------------------------------------------------}
Function LowStr(s:string):String;
var i:integer;
begin
 for i:=1 to length(s) do s[i]:=LowCase(s[i]);
 LowStr:=S;
end;
{-----------------------------------------------------}
Function DelComment(s:string):String;
var P:integer;
begin
 P:=Pos(CommentChar,S);
 if P>0 then DelComment:=Copy(S,1,P-1) else DelComment:=S;
end;
{----------------------------------------------------}
Function cntrs(s:string; Len:integer):string;
begin
 if length(s)<Len then
  begin
    while length(s)<Len do s:=' '+s+' ';
    if length(s)>Len then Delete(S,Length(S),1);
  end;
 Cntrs:=S;
end;
{--------------------------------------------}
Function DeTab(s:string; TabSize:Byte):string;
var i:integer;
begin
 For I:=Length(S) downto 1 do
  if s[i]=#9 then begin delete(s,i,1); insert(spaces(TabSize),s,i); end;
 DeTab:=S;
end;
{--------------------------------------------}
Function DLS(S:string):string;
begin
 while (S<>'') and (s[length(s)]='\') do Delete(S,Length(S),1);
 DLS:=S;
end;
{--------------------------------------------}
Function just(S:String;Len,LRC:longint):string;
begin
 if length(s)>Len then s[0]:=Char(Lo(Len));
 case LRC of
  1: just:=LeftPad(s,Len);         {'       '+s}
  2: just:=RightPad(s,Len);        {s+'       '}
  3: just:=Cntrs(S,Len);
  else just:=s; {11-01-99,BDS}
 end;
end;
{-------------------------------------------}
Function FilterStr(S:String;FilterChars:TCharSet;ReplaceChar:Char):String;
var i:integer;
begin
 for i:=1 to Length(S) do
  if (S[i] in FilterChars) then S[i]:=ReplaceChar;
 FilterStr:=S;
end;
{-------------------------------------------}
const
  XlatTable: array[0..4] of String[66] = (
{DOS}'',
{WIN}'',
{KOI}'',
{MIC}'',
{MKT}''
  );
{--------------------------------------------}
function XltStr(S: String; SourTable,DestTable: Integer): String;
var I, Idx: Integer;
    SourceChars, DestChars: PString;
begin
 if not(SourTable in [0..4]) or not(DestTable in [0..4]) then
  begin XltStr:=S; exit; end;
 SourceChars:= @XlatTable[SourTable];
 DestChars  := @XlatTable[DestTable];
 for I:= 1 to Length(S) do
   begin
     Idx:= Pos(S[I],SourceChars^);
     if Idx <> 0 then S[I]:= DestChars^[Idx];
   end;
 XltStr:= S;
end;
{--------------------------------------------}
Procedure XltBuf(var Buffer:PXltBuffer;NChars:Word; SourTable,DestTable:Integer);
var I, Idx: Word;
    SourceChars, DestChars: PString;
begin
 if not(SourTable in [0..4]) or not(DestTable in [0..4]) then exit;
 SourceChars:= @XlatTable[SourTable];
 DestChars  := @XlatTable[DestTable];
 if NChars<=0 then exit;
 for I:= 0 to (NChars-1) do
   begin
     Idx:= Pos(Buffer^[I],SourceChars^);
     if Idx <> 0 then Buffer^[I]:= DestChars^[Idx];
   end;
end;
{--------------------------------------------}
constructor TCodePageDetector.Init;
begin
 Inherited Init;
 Koi:=0; KoiA:=0; Win:=0; WinA:=0; Win2:=0;
end;
{--------------------------------------------}
destructor TCodePageDetector.Done;
begin
 Inherited Done;
end;
{--------------------------------------------}
const
  WinSetA = ['','','','',''];
  KoiSetA = ['','','','',''];
{--------------------------------------------}
procedure TCodePageDetector.CheckString(const S: String);
var
  J: Integer;
  C: Char;
  P1, P2: PChar;
begin
  P1:=@S[1]; P2:=P1+Length(S);
  while P1<P2 do
  begin
    C:=P1^; Inc(P1);
    if C >= #$C0 then
      if C <= #$DF then
      begin
        Inc(Koi); if C in KoiSetA then Inc(KoiA);
      end
      else begin
        Inc(Win); if C in WinSetA then Inc(WinA);
        if C >= #$F0 then Inc(Win2);
      end;
  end;
end;
{--------------------------------------------}
function TCodePageDetector.DetectCodePage: TKeyMap;
begin
  DetectCodePage:=kmAscii;
  if (Koi<>0) and (KoiA<>0) and (Win<>0) and
     (Win >= Koi/500) and (Win <= Koi/5) and
     (KoiA >= Koi/5) then DetectCodePage:=kmKoi8r
  else if (Win<>0) and (WinA<>0) and (Koi<>0) and
          (Koi >= Win/500) and (Koi <= Win/5) and
          (WinA >= Win/5) and (Win2 >= Win/5) then DetectCodePage:=kmAnsi;
end;
{--------------------------------------------}
Function OemToAnsi(S:String):String;
begin
 OemToAnsi:=XltStr(S,xTblDos,xTblWin);
end;
{--------------------------------------------}
Function AnsiToOem(S:String):String;
begin
 AnsiToOem:=XltStr(S,xTblWin,xTblDos);
end;
{--------------------------------------------}
Function OemToKoi(S:String):String;
begin
 OemToKoi:=XltStr(S,xTblDos,xTblKoi);
end;
{--------------------------------------------}
Function KoiToOem(S:String):String;
begin
 KoiToOem:=XltStr(S,xTblKoi,xTblDos);
end;
{--------------------------------------------}
Function ConvertStr(S,SourceChars,DestChars:String):String;
var i,Idx:integer;
begin
 for i:=1 to Length(S) do
  begin
   Idx:=Pos(S[i],SourceChars);
   if Idx>0 then S[I]:=DestChars[Idx];
  end;
 ConvertStr:=S;
end;
{--------------------------------------------}
Function DetectCodePage(S:String):Integer;
var CPD:PCodePageDetector;
begin
 CPD:=New(PCodePageDetector,Init);
 CPD^.CheckString(S);
 case CPD^.DetectCodePage of
  kmNone,
  kmAscii:DetectCodePage:=0; {xTblDos}
  kmAnsi :DetectCodePage:=1; {xTblWin}
  kmKoi8r:DetectCodePage:=2; {xTblKoi}
 end;
 Dispose(CPD,Done);
end;
{--------------------------------------------}
Function UpWordFirstCh(S:String; Delims:TCharSet):String;
{ aaa bbb ccc ddd -> Aaa Bbb Ccc Ddd}
var i:integer;
begin
 S:=RLowStr(S);
 for i:=2 to Length(S) do
  if (S[i-1] in Delims) and not(S[i] in Delims) then S[i]:=RUpCase(S[i]);
 if not (S[1] in Delims) then S[1]:=RUpCase(S[1]);
 UpWordFirstCh:=S;
end;
{--------------------------------------------}
Function WordCount(S:String; Delims:TCharSet):integer;
var i:integer;
    Wc:integer;
begin
 Wc:=0;
 for i:=2 to length(S) do
  if (S[i-1] in Delims) and not (S[i] in Delims) then Inc(Wc);
 if not (S[1] in Delims) then Inc(Wc);
 WordCount:=Wc;
end;
{--------------------------------------------}
Function WordPos(S:String; WordNum:integer; Delims:TCharSet):integer;
var i :integer;
    Wc:integer;
begin
i:=1; Wc:=0; WordPos:=0;
while S<>'' do
 BEGIN
  while (S<>'') and (S[1] in Delims) do begin Inc(i); Delete(S,1,1); end;
  if (S<>'') and not(S[1] in Delims) then Inc(Wc);
  if Wc=WordNum then begin WordPos:=i; Break; end;
  while (S<>'') and not (S[1] in Delims) do begin Inc(i); Delete(S,1,1); end;
 END;
end;
{--------------------------------------------}
Function ExtractWord(S:String;WordNum:integer; Delims:TCharSet):String;
var i,Wp:integer;
    Sbuf:String;
begin
 Wp:=WordPos(S,WordNum,Delims);
 Sbuf:='';
 if Wp<>0 then
  for i:=Wp to Length(S) do
   begin if not(S[i] in Delims) then Sbuf:=Sbuf+S[i] else break; end;
 ExtractWord:=Sbuf;
end;
{--------------------------------------------}
Function PercentStr(Cur,Max:Longint; EmptyCh,FillCh:Char; Len:byte):String;
var LF:integer;
begin
 LF:=Trunc((Len/100)*Trunc(100*(Cur/Max)));
 PercentStr:=FillStrChar(FillCh,LF)+FillStrChar(EmptyCh,Len-LF);
end;
{--------------------------------------------}
Function FloatToStr(R:Real):String;
var S:String;
begin
 Str(R:20,S); FloatToStr:=S;
end;
{--------------------------------------------}
Function StrToFloat(S:String):Real;
var Er:integer;
    R:Real;
begin
 Val(S,R,Er);
 if Er<>0 then StrToFloat:=2.9e-39 else StrToFloat:=R;
end;
{--------------------------------------------}
END.

